class Population{
	private int generation; //ȺĴ
	private int size;			//ȺС
	private Individual[] pop;   //Ⱥ
	private double averageFitness;    //ƽӦ
	private double[] relativeFitness;	//Ӧ
	private int chromlen;//򳤶
	Individual bestIndividual;//ǰӦõĸ
	Individual worstIndividual;//ǰӦĸ
	Individual currentBest;//ĿǰΪֹõĸ
	private int worstIndex;//bestIndividualӦ±

	
	public Population(int size){
		this.generation = 0;
		this.size = size;
		
		this.pop = new Individual[size];
		this.averageFitness = 0;
		this.relativeFitness = new double[size];
		this.chromlen = 20;
		
		for(int i = 0; i < size; i++){
			pop[i] = new RosenbrockIndividual(chromlen);
		}
	}
	
	
	//ʼȺ
	public void initPopulation(){
		for(int i = 0;i < size;i++){
			pop[i].generateIndividual();
		}
		
		findBestAndWorstIndividual();				
	}

	//----------------------------------------------------
	//ѡ
	public void  select(){
		double[] rouletteWheel; //
		Individual[] childPop = new Individual[size];
		
		calRelativeFitness();
		
		//
		rouletteWheel  = new double[size];
		rouletteWheel[0] = relativeFitness[0];
		for(int i=1;i<size -1;i++){
			rouletteWheel[i] = relativeFitness[i] + rouletteWheel[i - 1];
		}
		rouletteWheel[size - 1] = 1;
		
		//жѡ,Ⱥ
		for(int i = 0;i < size ; i++){
			double rnd = rand();
			for(int j = 0; j < size; j++){
				if(rnd < rouletteWheel[j]){
					childPop[i] = pop[j];
					break;
				}	
			}		 
		}
		
		for(int i = 0;i < size; i++){
			pop[i] = childPop[i];
		}
		
		//return 	childPop;
	}
	
	//Ӧ
	private double calTotalFitness(){
		double total = 0;
		for(int i = 0 ; i < size ;i++)
			total += pop[i].getFitness();
		return total;
	}
		
	//Ӧ
	public double[] calRelativeFitness(){
		double totalFitness = calTotalFitness();
		for(int i = 0 ;i < size ; i++){
			relativeFitness[i] = pop[i].getFitness() / totalFitness;	
		}
		
		return relativeFitness;
	}
	
	//================================
	
	//------------------------------------------------------
	//㽻
	public void crossover(){
		for(int i = 0 ; i < size/2*2; i+=2){
			int rnd;
			//
			rnd = rand(i , size);

			if(rnd != i)
				exchange(pop , i , rnd);
				
			rnd = rand(i , size);
			if(rnd != i+1)
				exchange(pop , i + 1 , rnd);	
					
			//
			double random = rand();

			if(random < GeneticAlgorithms.crossoverRate){
				cross(i);
			}			
		}
	}
	
	//ִн
	private void cross(int i){
		String chromFragment1,chromFragment2;//Ƭ
		
		int rnd = rand(0 , getChromlen() - 1);//Ϊrnd֮,ܵλchromlen - 1.
		chromFragment1 = pop[i].getChrom(rnd + 1 , getChromlen() - 1);
		chromFragment2 = pop[i+1].getChrom(rnd + 1 , getChromlen() - 1);
			
		pop[i].setChrom(rnd + 1 , getChromlen() - 1 , chromFragment2);
		pop[i+1].setChrom(rnd + 1 , getChromlen() - 1 , chromFragment1);			
	}
	
	//
	private int rand(int start , int end){//Ϊ[start , end)
		return (int)(rand()*(end - start) + start);
	}
	
	//
	private void exchange(Individual[] p ,int src , int dest){
		Individual temp;
		temp = p[src];
		p[src] = p[dest];
		p[dest] = temp;	
	}
	//==============================

	//-----------------------------------------------------
	//
	public void mutate(){
		for(int i = 0 ; i < size;i++){
			for(int j = 0 ;j < getChromlen(); j++){
				if(rand() < GeneticAlgorithms.mutateRate){
					pop[i].mutateSingleBit(j);
					///System.out.print(""+ i +" - "+ j + "  ");///
				}	
			}
		}
	}
	//==============================
	
	//-----------------------------------------------------
	//
	public void evolve(){
		select();
		crossover();
		mutate();
		evaluate();	
	}
	
	
	//==============================
	//Ŀ꺯ֵӦȡҳŸ塣
	public void evaluate(){
		//ͬĿ꺯ֵӦ
		for(int i = 0; i < size; i++){
			pop[i].calTargetValue();
			pop[i].calFitness();
		}
		
		//ʹű(Elitist Model)Ÿ
		findBestAndWorstIndividual();
		pop[worstIndex] = (Individual)currentBest.clone();
		
		generation++;	
	}	
	//ҳӦĸ
	public void findBestAndWorstIndividual(){
		bestIndividual = worstIndividual = pop[0];
		for(int i = 1; i <size;i++){
			if(pop[i].fitness > bestIndividual.fitness){
				bestIndividual = pop[i];
			}
			if(pop[i].fitness < worstIndividual.fitness){
				worstIndividual = pop[i];
				worstIndex = i;
			}
		}
	
		if( generation == 0 ){//ʼȺ
			currentBest = (Individual)bestIndividual.clone();
		}else{
			if(bestIndividual.fitness > currentBest.fitness)
				currentBest = (Individual)bestIndividual.clone();
		}
	}
	
	//жϽǷ
	public boolean isEvolutionDone(){
		if(generation < GeneticAlgorithms.maxGeneration)
			return false;
		return true;	
	}
		
	//ƽӦ
	public double calAverageFitness(){
		for(int i = 0 ; i < size; i++){
			averageFitness += pop[i].getFitness();
		}
		averageFitness/=size;
			
		return averageFitness;
	} 
				
	//
	private double rand(){
		return Math.random();
	}
	
	public int getChromlen(){
		return chromlen;
	}
	
	public void setGeneration(int generation){
		this.generation = generation;
	}
	
	public int getGeneration(){
		return generation;
	}
	/*
	public String printPop(Individual[] pop){
		String str="";
		for(int i = 0 ; i < size ; i++)
			str += pop[i];
		return str;
	}*/
	
	public String toString(){
		String str="";
		for(int i = 0 ; i < size ; i++)
			str += pop[i];
		return str;
	}	
}